#!/usr/bin/perl

# ARCADEmini binary concatenator: ambincat
# version 1.0 date 2003-10-09
# part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
# written by 1stein <1stein@schuermans.info>
# Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html

print <<EOF;
ARCADEmini binary concatenator: ambincat
version 1.0 date 2003-10-09
part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
written by 1stein <1stein\@schuermans.info>
Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html

EOF

if( @ARGV < 2 )
{
	print <<EOF;
syntax: ambincat <ambin-input-file 1> ... <ambin-input-file n> <ambin-output-file>

examples: ambincat in1.ambin in2.ambin out.ambin

EOF
	exit;
}

$ident = "ARCADEmini 26x20/16 ambin 1.0   ";
for( $i = 32; $i < 512; $i++ ) { $ident = $ident . pack( 'C', 0xFF ); }

$out_file = $ARGV[@ARGV - 1];
open( OutF, "> " . $out_file ) || die "Can't open output file \"$out_file\": $!\n";
binmode OutF;
print OutF $ident;

$sectors = 0;
$file_cnt = @ARGV - 1;
for( $file_no = 0; $file_no < $file_cnt; $file_no++ )
{
  $file = $ARGV[$file_no];
  if( open( InF, "< " . $file ) )
  {
    binmode InF;

    seek( InF, 0, 2 );
    $file_size = tell( InF );
    $file_sectors = ($file_size >> 9) - 2;

    seek( InF, 0, 0 );
    read( InF, $file_ident, 512 );

    seek( InF, ($file_sectors << 9) + 512, 0 );
    read( InF, $file_end, 512 );
    $file_end_1 = unpack( 'C', substr( $file_end, 0, 1 ) );
    $file_end_sec = unpack( 'C', substr( $file_end, 1, 1 ) );
    $file_end_sec = ($file_end_sec << 8) + unpack( 'C', substr( $file_end, 2, 1 ) );
    $file_end_sec = ($file_end_sec << 8) + unpack( 'C', substr( $file_end, 3, 1 ) );
    $file_end_sec = ($file_end_sec << 8) + unpack( 'C', substr( $file_end, 4, 1 ) );
    $file_end_sec = (0xFFFFFFFF - $file_end_sec) + 1;

    if( $file_ident eq $ident && $file_end_1 == 1 && $file_end_sec == $file_sectors )
    {

      print "\"$file\": $file_sectors data sectors\n";
      
      seek( InF, 512, 0 );
      for( $i = 0; $i < $file_sectors; $i++ )
      {
        read( InF, $buffer, 512 );
        print OutF $buffer;
      }
      $sectors += $file_sectors;
    
    } # if( $file_ident ...
    else
    {
      print "WARNING: Input file \"$file\" is not a valid ARCADEmini binary.\n";
    } # if( $file_ident ... else

    close InF;
  } # if( open( InF ...
  else
  {
    print "WARNING: Can't open input file \"$file\": $!\n";
  } # if( open( InF ... else ...
} # for( $file_no ...
print "\n";

print "\"$out_file\": $sectors data sectors\n";

$jump_sectors = 0xFFFFFFFF - ($sectors - 1);
print OutF pack( 'C', 0x01 );
print OutF pack( 'C', ($jump_sectors >> 24) & 0xFF );
print OutF pack( 'C', ($jump_sectors >> 16) & 0xFF );
print OutF pack( 'C', ($jump_sectors >> 8) & 0xFF );
print OutF pack( 'C', $jump_sectors & 0xFF );
for( $i = 5; $i < 512; $i++ ) { print OutF pack( 'C', 0x00 ); }

close( OutF );

print "\n";
